#!/usr/bin/env ruby

require 'gtk2'

# define functions to trigger

def another_tab; puts "Switching"; end
def report_press(w); puts "Somebody pressed gumbek (button) w=#{w}"; end

def change_password(user)
	# Create the dialog
	if user == "root"
		msg = "Passwort des Administrators setzen: Bitte geben Sie das Passwort zweimal ein." 
	else
		msg = "Nutzer-Passwort setzen: Bitte geben Sie das Passwort zweimal ein."
	end
	dialog = Gtk::Dialog.new("Passwort setzen",
		$main_application_window,
		Gtk::Dialog::MODAL,
		[Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_REJECT],
		[Gtk::Stock::OK, Gtk::Dialog::RESPONSE_ACCEPT])
	d_table = Gtk::Table.new(4,    2,    false)
	dt_options = Gtk::EXPAND|Gtk::FILL
	d_table.attach(Gtk::Label.new(msg),  0,  2,  0,  1, nil, nil, 5, 5)
	d_pass = Gtk::Entry.new
	d_pass.visibility = false
	c_pass = Gtk::Entry.new
	c_pass.visibility = false
	d_table.attach(d_pass,  1,  2,  1,  2, nil, nil, 5, 2)
	d_table.attach(c_pass,  1,  2,  2,  3, nil, nil, 5, 2)
	p_label = Gtk::Label.new("Passwort:")
	c_label = Gtk::Label.new("Bestätigung:")
	d_table.attach(p_label,  0,  1,  1,  2, nil, nil, 5, 2)
	d_table.attach(c_label,  0,  1,  2,  3, nil, nil, 5, 2)
	i_label = Gtk::Label.new("")
	d_table.attach(i_label,  0,  2,  3,  4, nil, nil, 5, 2)

	# Ensure that the dialog box is destroyed when the user responds.
	dialog.signal_connect('response') { |x|
		puts x[1]
		if (x[1] == -2)
			dialog.destroy
		else
			result, message = pw_check(c_pass.text, d_pass.text)
			if result == false
				i_label.text = message
			else
				system(	"echo -n " + c_pass.text + 
					" | openssl passwd -1 -stdin > /etc/lesslinux/" + user + ".hash") 
				system( "/etc/rc.d/0040-roothash.sh start")
				dialog.destroy
			end
		end
		# puts x[1]
		# i_label.text = pw_check(x[1])
	}
	dialog.vbox.add(d_table)
	dialog.show_all
end

# Check if two passwords match. Return true/false + a message 

def pw_check (pass, conf)
	if [pass.size, conf.size].min < 8 
		return false, "Das Passwort muss mindestens acht Zeichen lang sein!"
	elsif pass != conf
		return false, "Die Passwörter müssen übereinstimmen!"
	else
		return true, "Die Passwörter stimmen überein."
	end
	#if x == -2
	#	return "Das Passwort muss mindestens acht Zeichen lang sein!"
	#else
	#	return "Die Passwörter müssen übereinstimmen!"
	#end
end
# define base layout

window = Gtk::Window.new(Gtk::Window::TOPLEVEL)
window.set_title  "LessLinux - Einstellungen"
window.border_width = 10
window.set_size_request(740, 540)
window.signal_connect('delete_event') { Gtk.main_quit }

# notebook and tabs

nb = Gtk::Notebook.new
label1 = Gtk::Label.new("Netzwerk")
label2 = Gtk::Label.new("Laufwerke")
label3 = Gtk::Label.new("Freigaben")
label4 = Gtk::Label.new("Speicherung")
label5 = Gtk::Label.new("Nutzer")

note1  = Gtk::Label.new("Hier steht...")
note2  = Gtk::Label.new("...noch nicht...")
note3 = Gtk::Label.new("...besonders viel!")

# buttons

button = Gtk::Button.new("Gumbek")
cont =  Gtk::Button.new("Weiter")
back =  Gtk::Button.new("Zurück")

# scrolled window for the tab users

swin       = Gtk::ScrolledWindow.new
swin.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)

table_box = Gtk::VBox.new(true, 0)
table = Gtk::Table.new(4,    2,    false)

t_options = Gtk::EXPAND|Gtk::FILL

lx1 = Gtk::Label.new("Enter the following information ...")
lx2 = Gtk::Label.new("Name: ")
t_name = Gtk::Entry.new
initial_font = Pango::FontDescription.new("Sans Bold 12")
lx1.modify_font(initial_font)

user_label = Gtk::Label.new("Nutzer-Passwort")
user_label.modify_font(initial_font)
root_label = Gtk::Label.new("Administrator-Passwort")
root_label.modify_font(initial_font)
user_desc = Gtk::Label.new("Sie benötigen das Nutzer-Passwort, wenn Sie im laufenden System Laufwerke ein- oder aushängen wollen. Für maximale Sicherheit vergeben Sie kein Passwort. Wenn Sie auf interne Laufwerke oder USB-Sticks zugreifen wollen, vergeben Sie jetzt ein Passwort.")
user_desc.wrap = true
user_button = Gtk::Button.new("Nutzer-Passwort setzen")
user_button.signal_connect( "clicked" ) {|w| change_password("surfer") }
user_button_box = Gtk::VBox.new(true, 0)
user_button_box.pack_start(user_button, false, false, 0)
root_desc = Gtk::Label.new("Sie benötigen ein Administrator-Passwort nur, wenn Sie weitergehende Wartungsarbeiten durchführen wollen, oder wenn der Support Sie um weiterführende Informationen bittet.")
root_desc.wrap = true
root_button =  Gtk::Button.new("Admin-Passwort setzen")
root_button.signal_connect( "clicked" ) {|w| change_password("root") }
root_button_box = Gtk::VBox.new(true, 0)
root_button_box.pack_start(root_button, false, false, 0)

            #     child, x1, x2, y1, y2, x-opt,   y-opt,   xpad, ypad
# table.attach(user_label,  0,  2,  0,  1, t_options, t_options, 0,    0)
table.attach(user_label,  0,  2,  0,  1, nil, nil, 5,    25)
table.attach(user_desc,  0,  1,  1,  2, t_options, t_options, 5,    5)
user_desc.set_alignment(0, 0.5 )
table.attach(user_button_box,  1,  2,  1,  2, t_options, t_options, 5,    5)
table.attach(root_label,  0,  2,  2,  3, nil, nil, 5,    25)
table.attach(root_desc,  0,  1,  3,  4, t_options, t_options, 5,    5)
root_desc.set_alignment(0, 0.5)
table.attach(root_button_box,  1,  2,  3,  4, t_options, t_options, 5,    5)
table_box.pack_start(table, false, false, 0)

#table.attach(lx2,  0,  1,  1,  2, t_options, t_options, 0,    0)
#table.attach(t_name,    1,  2,  1,  2, t_options, t_options, 0,    0)

swin.add_with_viewport(table_box)


# ======================================

button.signal_connect( "clicked" ) {|w| report_press(w) }

cont.width_request = 80
back.width_request = 80

cont.signal_connect( "clicked" ) {|w| 
	if cont.label == "Beenden"
		Gtk.main_quit
	end
	nb.next_page 
	puts nb.page.to_s
	if (nb.page > 3)
		cont.set_label("Beenden")
	end
	if (nb.page == 0)
		back.sensitive = false
	else
		back.sensitive = true
	end
}

back.signal_connect( "clicked" ) {|w| 
	nb.prev_page 
	puts nb.page.to_s
	if (nb.page < 4)
		cont.set_label("Weiter")
	end
	if (nb.page == 0)
		back.sensitive = false
	else
		back.sensitive = true
	end
	
}

nb.signal_connect('switch-page') { |i,k,j|
	puts 'Hulla!'
	puts j.to_s
	if (j < 4)
		cont.set_label("Weiter")
	else
		cont.set_label("Beenden")
	end
	if (j < 1)
		back.sensitive = false
	else
		back.sensitive = true
	end
}

# nb.signal_connect { |s| puts s.to_s }

vbox = Gtk::VBox.new(false, 7)
bbox = Gtk::HBox.new(false, 0)

nb.append_page(note1, label1)
nb.append_page(note2, label2)
nb.append_page(note3,  label3)
nb.append_page(note3,  label4)
nb.append_page(swin,  label5)

vbox.pack_start(nb, true, true)
bbox.pack_end(cont, false, false, 0)
bbox.pack_end(back, false, false, 0)
vbox.pack_end(bbox, false, false, 0)

window.add(vbox)
window.show_all
Gtk.main
